<!DOCTYPE html>
<html lang="en">
	<head>
		<title>List users</title>
		<meta charset="utf-8" />
		<meta name="viewport" content="width=device-width, initial-scale=1" />
		<link
			rel="stylesheet"
			href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css"
		/>
		<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
		<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

		<!-- Import Datatable sau jquery -->
		<!-- Import them style bootstrap cho datatable -->
		<link
			rel="stylesheet"
			href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css"
		/>
		<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
		<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
	</head>
	<body>
		<div class="container">
			<div class="text-center mt-4 mb-3">
				<h2>Danh sách người dùng</h2>
			</div>

			<table
				id="user-table"
				class="table table-bordered table-striped table-hover"
			>
				<thead>
					<tr>
						<td>STT</td>
						<td>Username</td>
						<td>First name</td>
						<td>Last name</td>
						<td>Email</td>
						<td>Age</td>
						<td>Role</td>
						<td>Action</td>
					</tr>
				</thead>
				<tbody></tbody>
			</table>
		</div>
		​
		<script>
			/***
    * TODO: gán data user vào DataTale, render cột STT và mapping được roleId thành roleName
    
    *** Gợi ý cho cột STT ***
    * a) sử dụng phương thức render trong cột STT (định nghĩa ở columnDefs); 
    * b) khai báo 1 biến toàn cục STT và mỗi lần render thì tăng lên 1
    
    * *** Gợi ý cho cột role ***
    * a) sử dụng phương thức render trong cột Role (định nghĩa ở columnDefs); 
    * b) khai báo 1 hàm từ roleId trả về roleName, và đc gọi hàm này trong phương thức render ở trên
  */

			$(document).ready(function () {
				/*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
				var gJsonUser = `{
      "description": "Data user",
      "users": [
      {
        "id": 2,
        "username": "quannv",
        "firstname": "Ngo Van",
        "lastname": "Quan",
        "age": 18,
        "email": "quan@gmail.com",
        "roleId": 5
      },
      {
        "id": 3,
        "username": "longdh",
        "firstname": "Do Hoang",
        "lastname": "Long",
        "age": 19,
        "email": "long@gmail.com",
        "roleId": 8
      },
      {
        "id": 4,
        "username": "hiendt",
        "firstname": "Do Thi",
        "lastname": "Hien",
        "age": 29,
        "email": "hien@gmail.com",
        "roleId": 11
      },
      {
        "id": 6,
        "username": "lanht",
        "firstname": "Ho Thi",
        "lastname": "Lan",
        "age": 27,
        "email": "lan@gmail.com",
        "roleId": 13
      }
    ]
  }`;
				var gJsonRole = `{
      "description": "User Roles",
      "roles": [
        {
          "roleId": 5,
          "roleName": "Admin" 
        },
        {
          "roleId": 8,
          "roleName": "Manager" 
        },
        {
          "roleId": 11,
          "roleName": "Teacher" 
        },
        {
          "roleId": 13,
          "roleName": "Staff" 
        }
      ]
    }`;

				var gListUser = JSON.parse(gJsonUser);
				var gListRole = JSON.parse(gJsonRole);
				console.log(gListUser);
				var gNameCol = [
					'id',
					'username',
					'firstname',
					'lastname',
					'age',
					'email',
					'roleId',
					'action',
				]; //cột điểm sẽ là dữ liệu để tính ra cột xếp hạng

				/*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
				onPageLoading();

				$(document).on('click', '#user-table .btn-detail', function () {
					//gán sự kiện xử lý onclick cho các button trong bảng user table, có class là btn-detail
					onBtnDetailClick(this);
				});

				/*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
				function onPageLoading() {
					/* Hãy đổ dữ liệu vào table và thực hiện nút information (chi tiết)
					 * dùng cách khai báo data source ngay từ đầu */
					$('#user-table').DataTable({
						data: gListUser.users,
						columns: [
							{ data: gNameCol[0] },
							{ data: gNameCol[1] },
							{ data: gNameCol[2] },
							{ data: gNameCol[3] },
							{ data: gNameCol[4] }, // giá trị của cột xếp hạng ta mặc định lấy là cột điểm (lấy luôn giá trị đó, khi hiện thị ta mới xử lý)
							{ data: gNameCol[5] },
							{ data: gNameCol[6] },
							{ data: gNameCol[7] },
						],
						columnDefs: [
							//định nghia các cột cần hiện ra
							{
								targets: 0, //cột ID
								className: 'text-center text-primary',
								render: chuyenIdThanhStt,
							},
							{
								targets: 6,
								className: 'text-right',
								render: chuyenRoleIdThanhRoleName, //tuy dữ liệu lấy vào ô vẫn là điểm (grade), nhưng ta đã xử lý bằng function chuyenDiemThanhXepHang để thay đỏi hiện thị
							},
							{
								targets: 7, //cột Action
								className: 'text-center',
								defaultContent:
									"<button class='btn btn-primary btn-detail'> Chi tiết </button>", //nội dung html của cột là nút button, class btn-detail để đánh dấu các nút hiện information
							},
						],
					});
				}

				function onBtnDetailClick(paramElement) {
					'use strict';
					var vRowClick = $(paramElement).closest('tr'); // Xác định tr chứa nút bấm được click
					var vTable = $('#user-table ').DataTable(); // tạo biện truy xuất đến datatable
					var vDataRow = vTable.row(vRowClick).data(); // Lấy dữ liệu của hàng dữ liệu chứa nút bấm được click
					console.log(vDataRow);
				}

				/*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
				function chuyenRoleIdThanhRoleName(paramData, paramType, paramRow) {
					var vRoleName = 'fff';
					console.log(paramData);
					console.log('type = ' + paramType); //type có thể là display (dữ liệu hiện thị), filter (dữ liệu khi lọc), sort (dữ liệu khi sắp xếp); TRONG BÀI NÀY, ta trả vè giống nhau
					for (var bI = 0; bI < gListRole.roles.length; bI++) {
						if (paramData === gListRole.roles[bI].roleId) {
							vRoleName = gListRole.roles[bI].roleName;
						}
					}

					return vRoleName;
				}
				function chuyenIdThanhStt(paramData, paramType, paramRow) {
					var vStt = 0;
					for (var bI = 0; bI < gListUser.users.length; bI++) {
						if (paramData === gListUser.users[bI].id) {
							vStt = bI + 1;
						}
					}
					return vStt;
				}
			});
		</script>
	</body>
</html>
